#include "defines.h"
#include <iocslib.h>

void remake_pat(unsint *cch,int size,int c)
{
unsint *palad=(unsint *)0xe82200;
unchar ch[16*16],cc;
int x,y,col;
	col=(c>>8)&0x0f;
	sp_pat(c&0xff,ch,size/8-1);
	if (c&BIT14) { /* 水平方向反転 */
		for (y=0;y<size;y++) {
			for (x=0;x<size/2;x++) {
				cc=ch[y*size+x];
				ch[y*size+x]=ch[(y+1)*size-1-x];
				ch[(y+1)*size-1-x]=cc;
			}
		}
	}
	if (c&BIT15) { /* 垂直方向反転 */
		for (y=0;y<size/2;y++) {
			for (x=0;x<size;x++) {
				cc=ch[y*size+x];
				ch[y*size+x]=ch[(size-1-y)*size+x];
				ch[(size-1-y)*size+x]=cc;
			}
		}
	}
	/* 色特定（１６／２５６色 <- ６５５３６色）*/
	for (y=0;y<size;y++) {
		for (x=0;x<size;x++) {
			/* 全てパレットブロックから実際の色を特定 */
			cch[y*size+x]=B_WPEEK(palad+col*16+ch[y*size+x]);
		}
	}
}
